#include "DxLib.h"

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	ChangeWindowMode( TRUE ) ;

	if( DxLib_Init() == -1 )
	{
		return -1 ;
	}

	int pshandle = LoadPixelShader(  "PixelShader.pso" ) ;

	SetDrawScreen( DX_SCREEN_BACK ) ;

	SetUsePixelShader( pshandle ) ;

	VERTEX2DSHADER Vert[ 6 ] ;
	
	Vert[ 0 ].pos = VGet( 0.0f, 0.0f, 0.0f ) ;
	Vert[ 0 ].rhw = 1.0f ;
	Vert[ 0 ].dif = GetColorU8( 255,   0,  0,255 ) ;
	Vert[ 0 ].spc = GetColorU8(   0, 255,  0,  0 ) ;
	Vert[ 0 ].u   = 0.0f ;
	Vert[ 0 ].v   = 0.0f ;
	Vert[ 0 ].su  = 0.0f ;
	Vert[ 0 ].sv  = 0.0f ;

	Vert[ 1 ].pos = VGet( 128.0f, 0.0f, 0.0f ) ;
	Vert[ 1 ].rhw = 1.0f ;
	Vert[ 1 ].dif = GetColorU8( 255,   0,  0,255 ) ;
	Vert[ 1 ].spc = GetColorU8(   0, 255,  0,  0 ) ;
	Vert[ 1 ].u   = 0.0f ;
	Vert[ 1 ].v   = 0.0f ;
	Vert[ 1 ].su  = 0.0f ;
	Vert[ 1 ].sv  = 0.0f ;

	Vert[ 2 ].pos = VGet( 0.0f, 128.0f, 0.0f ) ;
	Vert[ 2 ].rhw = 1.0f ;
	Vert[ 2 ].dif = GetColorU8( 255,   0,  0,255 ) ;
	Vert[ 2 ].spc = GetColorU8(   0, 255,  0,  0 ) ;
	Vert[ 2 ].u   = 0.0f ;
	Vert[ 2 ].v   = 0.0f ;
	Vert[ 2 ].su  = 0.0f ;
	Vert[ 2 ].sv  = 0.0f ;

	Vert[ 3 ].pos = VGet( 128.0f, 128.0f, 0.0f ) ;
	Vert[ 3 ].rhw = 1.0f ;
	Vert[ 3 ].dif = GetColorU8( 255,   0,  0,255 ) ;
	Vert[ 3 ].spc = GetColorU8(   0, 255,  0,  0 ) ;
	Vert[ 3 ].u   = 0.0f ;
	Vert[ 3 ].v   = 0.0f ;
	Vert[ 3 ].su  = 0.0f ;
	Vert[ 3 ].sv  = 0.0f ;

	Vert[ 4 ] = Vert[ 2 ];
	Vert[ 5 ] = Vert[ 1 ];
	
	DrawPolygon2DToShader( Vert, 2 ) ;

	ScreenFlip() ;

	WaitKey() ;

	DxLib_End() ;				// cwCugp̏I

	return 0 ;					// \tg̏I
}